signature DataCacheBlocking where {
import Assert;
		
import Counter;
		 
import FIFOF_;
		
import FIFOF;
	       
import FIFO;
	      
import Inout;
	       
import List;
	      
import BFIFO;
	    
import Clocks;
		
import ListN;
	       
import PrimArray;
		   
import RegFile;
		 
import Vector;
		
import Connectable;
		     
import GetPut;
		
import ClientServer;
		      
import Trace;
	    
import MemTypes;
	       
import ProcTypes;
		
interface (DataCacheBlocking.DCacheStats :: *) = {
    DataCacheBlocking.num_accesses :: GetPut.Get ProcTypes.Stat;
    DataCacheBlocking.num_misses :: GetPut.Get ProcTypes.Stat;
    DataCacheBlocking.num_writebacks :: GetPut.Get ProcTypes.Stat
};
 
instance DataCacheBlocking Prelude.PrimMakeUndefined DataCacheBlocking.DCacheStats;
											
instance DataCacheBlocking Prelude.PrimDeepSeqCond DataCacheBlocking.DCacheStats;
										      
instance DataCacheBlocking Prelude.PrimMakeUninitialized DataCacheBlocking.DCacheStats;
											    
interface (DataCacheBlocking.DCache :: * -> * -> *) req_t resp_t = {
    DataCacheBlocking.proc_server :: ClientServer.Server req_t resp_t;
    DataCacheBlocking.mmem_client :: ClientServer.Client MemTypes.MainMemReq MemTypes.MainMemResp;
    DataCacheBlocking.statsEn_put :: GetPut.Put Prelude.Bool;
    DataCacheBlocking.stats :: DataCacheBlocking.DCacheStats
};
 
instance DataCacheBlocking (Prelude.PrimMakeUndefined resp_t) =>
			   Prelude.PrimMakeUndefined (DataCacheBlocking.DCache req_t resp_t);
												  
instance DataCacheBlocking (Prelude.PrimDeepSeqCond resp_t) =>
			   Prelude.PrimDeepSeqCond (DataCacheBlocking.DCache req_t resp_t);
												
instance DataCacheBlocking Prelude.PrimMakeUninitialized
			   (DataCacheBlocking.DCache req_t resp_t);
								  
type (DataCacheBlocking.CacheLineIndexSz :: #) = 10;
						   
type (DataCacheBlocking.CacheLineTagSz :: #) = 20;
						 
type (DataCacheBlocking.CacheLineSz :: #) = 32;
					      
type (DataCacheBlocking.CacheLineIndex :: *) = Prelude.Bit DataCacheBlocking.CacheLineIndexSz;
												   
type (DataCacheBlocking.CacheLineTag :: *) = Prelude.Bit DataCacheBlocking.CacheLineTagSz;
											       
type (DataCacheBlocking.CacheLine :: *) = Prelude.Bit DataCacheBlocking.CacheLineSz;
											 
data (DataCacheBlocking.CacheStage :: *) =
    DataCacheBlocking.Init () |
    DataCacheBlocking.Access () |
    DataCacheBlocking.RefillReq () |
    DataCacheBlocking.RefillResp ();
				   
instance DataCacheBlocking Prelude.PrimMakeUndefined DataCacheBlocking.CacheStage;
										       
instance DataCacheBlocking Prelude.PrimDeepSeqCond DataCacheBlocking.CacheStage;
										     
instance DataCacheBlocking Prelude.PrimMakeUninitialized DataCacheBlocking.CacheStage;
											   
instance DataCacheBlocking Prelude.Eq DataCacheBlocking.CacheStage;
									
instance DataCacheBlocking Prelude.Bits DataCacheBlocking.CacheStage 2;
									    
DataCacheBlocking.getAddr :: MemTypes.DataReq -> Prelude.Bit MemTypes.AddrSz;
										  
DataCacheBlocking.getCacheLineIndex :: MemTypes.DataReq -> DataCacheBlocking.CacheLineIndex;
											   
DataCacheBlocking.getCacheLineTag :: MemTypes.DataReq -> DataCacheBlocking.CacheLineTag;
										       
DataCacheBlocking.getCacheLineAddr :: MemTypes.DataReq -> Prelude.Bit MemTypes.AddrSz;
											   
DataCacheBlocking.mkDataCache :: (Prelude.IsModule _m__ _c__) =>
				 _m__ (DataCacheBlocking.DCache MemTypes.DataReq MemTypes.DataResp)
}
